TelepathyQt4: ChannelRequestInterface Class Reference

| Home · All Classes · All Namespaces · Modules · Functions · Files

# ChannelRequestInterface Class Reference
[ChannelRequest proxies]

`#include <TelepathyQt4/ChannelRequest>`

Inherits Tp::AbstractInterface.

List of all members.

## Public Slots

- QDBusPendingReply Proceed ()
- QDBusPendingReply Cancel ()

## Signals

- void Failed (const QString &error, const QString &message)
- void Succeeded ()

## Public Member Functions

- ChannelRequestInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
- ChannelRequestInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
- ChannelRequestInterface (Tp::DBusProxy *proxy)
- QDBusObjectPath Account () const TELEPATHY_GNUC_DEPRECATED
- qlonglong UserActionTime () const TELEPATHY_GNUC_DEPRECATED
- QString PreferredHandler () const TELEPATHY_GNUC_DEPRECATED
- Tp::QualifiedPropertyValueMapList Requests () const TELEPATHY_GNUC_DEPRECATED
- QStringList Interfaces () const TELEPATHY_GNUC_DEPRECATED

## Static Public Member Functions

- static const char * staticInterfaceName ()

## Protected Member Functions

- virtual void invalidate (Tp::DBusProxy *, const QString &, const QString &)

## Properties

- QDBusObjectPath Account
- qlonglong UserActionTime
- QString PreferredHandler
- Tp::QualifiedPropertyValueMapList Requests
- QStringList Interfaces

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.ChannelRequest."

## Constructor & Destructor Documentation

ChannelRequestInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0` |
| ) |  |  |

Creates a ChannelRequestInterface associated with the given object on the session bus.

Parameters:

  | busName | Name of the service the object is on.
  | objectPath | Path to the object on the service.
  | parent | Passed to the parent class constructor.

ChannelRequestInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0` |
| ) |  |  |

Creates a ChannelRequestInterface associated with the given object on the given bus.

Parameters:

  | connection | The bus via which the object can be reached.
  | busName | Name of the service the object is on.
  | objectPath | Path to the object on the service.
  | parent | Passed to the parent class constructor.

ChannelRequestInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a ChannelRequestInterface associated with the same object as the given proxy.

Parameters:

  | proxy | The proxy to use. It will also be the QObject::parent() for this object.

## Member Function Documentation

static const char* staticInterfaceName | ( |  | ) | `[inline, static]`

Returns the name of the interface "org.freedesktop.Telepathy.ChannelRequest", which this class represents.

Returns:
  The D-Bus interface name.

QDBusObjectPath Account | ( |  | ) | const`[inline]`

Getter for the remote object property "Account".

Don't use this: it blocks the main loop.

Returns:
  The value of the property, or a default-constructed value if the property is not readable.

qlonglong UserActionTime | ( |  | ) | const`[inline]`

Getter for the remote object property "UserActionTime".

Don't use this: it blocks the main loop.

Returns:
  The value of the property, or a default-constructed value if the property is not readable.

QString PreferredHandler | ( |  | ) | const`[inline]`

Getter for the remote object property "PreferredHandler".

Don't use this: it blocks the main loop.

Returns:
  The value of the property, or a default-constructed value if the property is not readable.

Tp::QualifiedPropertyValueMapList Requests | ( |  | ) | const`[inline]`

Getter for the remote object property "Requests".

Don't use this: it blocks the main loop.

Returns:
  The value of the property, or a default-constructed value if the property is not readable.

QStringList Interfaces | ( |  | ) | const`[inline]`

Getter for the remote object property "Interfaces".

Don't use this: it blocks the main loop.

Returns:
  The value of the property, or a default-constructed value if the property is not readable.

QDBusPendingReply Proceed | ( |  | ) | `[inline, slot]`

Begins a call to the D-Bus method "Proceed" on the remote object.

Proceed with the channel request.

<tp:rationale>

The client that created this object calls this method when it has connected signal handlers for <tp:member-ref>Succeeded</tp:member-ref> and <tp:member-ref>Failed</tp:member-ref>. </tp:rationale>

Clients other than the client which created the ChannelRequest MUST NOT call this method.

This method SHOULD return immediately; on success, the request might still fail, but this will be indicated asynchronously by the <tp:member-ref>Failed</tp:member-ref> signal.

Proceed cannot fail, unless clients have got the life-cycle of a ChannelRequest seriously wrong (e.g. a client calls this method twice, or a client that did not create the ChannelRequest calls this method). If it fails, clients SHOULD assume that the whole ChannelRequest has become useless.

QDBusPendingReply Cancel | ( |  | ) | `[inline, slot]`

Begins a call to the D-Bus method "Cancel" on the remote object.

Cancel the channel request. The precise effect depends on the current progress of the request.

If the connection manager has not already been asked to create a channel, then <tp:member-ref>Failed</tp:member-ref> is emitted immediately, and the channel request is removed.

If the connection manager has already been asked to create a channel but has not produced one yet (e.g. if <tp:dbus-ref namespace="org.freedesktop.Telepathy">Connection.Interface.Requests.CreateChannel</tp:dbus-ref> has been called, but has not yet returned), then the ChannelDispatcher will remember that the request has been cancelled. When the channel appears, it will be closed (if it was newly created and can be closed), and will not be dispatched to a handler.

If the connection manager has already returned a channel, but the channel has not yet been dispatched to a handler then the channel dispatcher will not dispatch that channel to a handler. If the channel was newly created for this request, the channel dispatcher will close it with <tp:dbus-ref namespace="org.freedesktop.Telepathy.Channel">Close</tp:dbus-ref>; otherwise, the channel dispatcher will ignore it. In either case, <tp:member-ref>Failed</tp:member-ref> will be emitted when processing has been completed.

If <tp:member-ref>Failed</tp:member-ref> is emitted in response to this method, the error SHOULD be `org.freedesktop.Telepathy.Error.Cancelled`.

If the channel has already been dispatched to a handler, then it's too late to call this method, and the channel request will no longer exist.

void Failed | ( | const QString & | error,
|  | const QString & | message |
| ) |  |  | `[signal]`

Represents the signal "Failed" on the remote object.

The channel request has failed. It is no longer present, and further methods must not be called on it.

Parameters:

  | error |

The name of a D-Bus error. This can come from various sources, including the error raised by <tp:dbus-ref namespace="org.freedesktop.Telepathy.Connection.Interface.Requests">CreateChannel</tp:dbus-ref>, or an error generated to represent failure to establish the <tp:dbus-ref namespace="org.freedesktop.Telepathy">Connection</tp:dbus-ref>.

Parameters:

  | message | If the first argument of the D-Bus error message was a string, that string. Otherwise, an empty string.

void Succeeded | ( |  | ) | `[signal]`

Represents the signal "Succeeded" on the remote object.

The channel request has succeeded. It is no longer present, and further methods must not be called on it.

virtual void invalidate | ( | Tp::DBusProxy * | ,
|  | const QString & | ,
|  | const QString & |  |
| ) |  |  | `[protected, virtual]`

## Property Documentation

QDBusObjectPath Account`[read]`

Represents property "Account" on the remote object.

The Account on which this request was made. This property cannot change.

qlonglong UserActionTime`[read]`

Represents property "UserActionTime" on the remote object.

The time at which user action occurred, or 0 if this channel request is for some reason not involving user action.

This corresponds to the _NET_WM_USER_TIME property in EWMH.

This property is set when the channel request is created, and can never change.

QString PreferredHandler`[read]`

Represents property "PreferredHandler" on the remote object.

Either the well-known bus name (starting with `org.freedesktop.Telepathy.Client.`) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable.

This property is set when the channel request is created, and can never change.

Tp::QualifiedPropertyValueMapList Requests`[read]`

Represents property "Requests" on the remote object.

An array of dictionaries containing desirable properties for the channel or channels to be created.

<tp:rationale>

This is an array so that we could add a CreateChannels method in future without redefining the API of ChannelRequest. </tp:rationale>

This property is set when the channel request is created, and can never change.

QStringList Interfaces`[read]`

Represents property "Interfaces" on the remote object.

A list of the extra interfaces provided by this channel request. This property cannot change.